#include <engine/psx.h>
#include <engine/timer.h>

/*
 * set_timer:
 *	Initializes the members of a Timer struct.
 */
void
set_timer(p_timer, vblnk_start, length, is_stopped)
struct Timer *p_timer;
int vblnk_start, length, is_stopped;
{
	p_timer->vblnk_start = vblnk_start;
	p_timer->length = length;
	p_timer->is_stopped = is_stopped;
}

/*
 * timer_has_completed:
 *	Checks if the timer has run its course via
 *	absolute time.
 */
timer_has_completed(p_timer)
struct Timer *p_timer;
{
	if(VSync(-1) > (p_timer->vblnk_start + p_timer->length))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

/*
 * timer_seconds:
 *	Returns the total amount of seconds left from a given
 *	timer.
 */
timer_seconds(p_timer)
struct Timer *p_timer;
{
	return ((p_timer->vblnk_start + p_timer->length)-VSync(-1))/SECOND;
}

